!BlockClosure methods!
asParser
	^ PPPluggableParser on: self
!  !
!Character class methods!  
codePoint: anInteger
	"
	Just for ANSI Compliance
	"
	^self value: anInteger
! !
!Character methodsFor: #'*petitparser-core-operators'! 
- aCharacter
	"Create a range of characters between the receiver and the argument."
	
	^ PPPredicateObjectParser between: self and: aCharacter
!   !
!Character methodsFor: #'*petitparser-converting'! 
asParser
	^ PPLiteralObjectParser on: self
!   !
!Character methods!
sameAs: aCharacter
	^self asLowercase = aCharacter asLowercase
!  !
!IndexedCollection methods!
asParser
	^ PPSequenceParser withAll: (self collect: [ :each | each asParser ])
! !
!IndexedCollection methods!
asPetitStream
	^ PPStream on: self
!  !
!IndexedCollection methods!
keysAndValuesDo: aBlock
	1 to: self size do: [:index | aBlock value: index value: (self at: index)]
! !
!Object methods!   
-> anObject
	^Association key: self value: anObject
! !
!Object methods!   
asParser
	^ PPPredicateObjectParser expect: self
!    !
!Object methods!   
isPetitFailure
	^ false
! !
!Object methodsFor: #'*petitparser-core-testing'!  
isPetitParser
	^ false
!   !
!ReadStream class methods! 
on: aCollection from: firstIndex to: lastIndex 
	"Answer with a new instance streaming over a copy of aCollection from
	firstIndex to lastIndex."

	^self basicNew
		on: aCollection
		from: firstIndex
		to: lastIndex
!   !
!ReadStream methods!   
on: aCollection from: firstIndex to: lastIndex
	| len |
	collection := aCollection.
	readLimit := lastIndex > (len := collection size)
		ifTrue: [len]
		ifFalse: [lastIndex].
	position := firstIndex <= 1 ifTrue: [0] ifFalse: [firstIndex - 1]
!  !
!RTFText methods!  
asPetitStream
	^ self asString asPetitStream
!    !
!Stream class methods! 
on: aCollection from: firstIndex to: lastIndex 
	"Answer an instance of me, streaming over the elements of aCollection 
	starting with the element at firstIndex and ending with the one at 
	lastIndex."

	^self basicNew on: (aCollection copyFrom: firstIndex to: lastIndex)
! !
!Stream methods!   
asPetitStream
	^ self contents asPetitStream
!    !
!String methods!   
copyReplaceAll: aString with: anotherString
	^self replaceAll: aString with: anotherString
!  !
!String methods!   
includesSubString: aString
	^aString isEmpty or: [(self indexOfString: aString) > 0]
!    !
!String methods!   
sameAs: aString
	^self equalsIgnoreCase: aString
!    !
!Symbol methods!   
value: anObject
	^anObject perform: self
!    !
!WriteStream class methods!
on: aCollection from: firstIndex to: lastIndex 
	"Answer an instance of me on a copy of the argument, aCollection, 
	determined by the indices firstIndex and lastIndex. Position the instance 
	at the beginning of the collection."

	^self basicNew
		on: aCollection
		from: firstIndex
		to: lastIndex
!  !
!WriteStream methods!  
on: aCollection from: firstIndex to: lastIndex

	| len |
	collection := aCollection.
	readLimit := 
		writeLimit := lastIndex > (len := collection size)
						ifTrue: [len]
						ifFalse: [lastIndex].
	position := firstIndex <= 1
				ifTrue: [0]
				ifFalse: [firstIndex - 1]
!    !
