"evaluate"
TestCase subclass: #PPAbstractParseTest
instanceVariableNames: ''
classVariableNames: ''
poolDictionaries: ''
!
"evaluate"   
PPAbstractParseTest subclass: #PPCompositeParserTest
instanceVariableNames: 
	' parser '
classVariableNames: ''
poolDictionaries: ''
!
"evaluate"   
TestResource subclass: #PPParserResource
instanceVariableNames: 
	' parsers '
classVariableNames: ''
poolDictionaries: ''
!
!PPParserResource methodsFor: #accessing!   
parserAt: aParserClass
	"Answer a cached instance of aParserClass."
	
	^ parsers at: aParserClass name ifAbsentPut: [ aParserClass new ]
! !
!PPParserResource methodsFor: #running!
setUp
	super setUp.
	parsers := Dictionary new
!   !
!PPAbstractParseTest class methodsFor: #testing!   
isAbstract
	^ self name = #PPAbstractParseTest
!   !
!PPAbstractParseTest class methodsFor: #accessing! 
packageNamesUnderTest
	^ #('PetitParser' 'PetitTests')
!   !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser fail: aCollection
	| stream result |
	self assert: aParser isPetitParser.
	stream := aCollection asPetitStream.
	result := aParser parse: stream.
	self assert: result isPetitFailure.
	self assert: stream position = 0
! !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aCollection
	self assert: aParser parse: aCollection to: nil end: aCollection size 
!   !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aCollection end: anInteger
	self assert: aParser parse: aCollection to: nil end: anInteger
!    !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aCollection to: anObject
	self assert: aParser parse: aCollection to: anObject end: aCollection size 
! !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aParseObject to: aTargetObject end: anInteger
	| stream result |
	self assert: aParser isPetitParser.
	stream := aParseObject asPetitStream.
	result := aParser parse: stream.
	aTargetObject isNil
		ifTrue: [ self deny: result isPetitFailure ]
		ifFalse: [ self assert: result = aTargetObject ].
	self assert: stream position = anInteger
!  !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aParserObject toToken: from stop: to
	| token |
	token := PPToken on: aParserObject start: from stop: to.
	^ self assert: aParser parse: aParserObject to: token
!  !
!PPAbstractParseTest methodsFor: #utilities!   
assert: aParser parse: aParserObject toToken: from stop: to end: end
	| token |
	token := PPToken on: aParserObject start: from stop: to.
	^ self assert: aParser parse: aParserObject to: token end: end
!    !
!PPCompositeParserTest class methodsFor: #testing! 
isAbstract
	^ self name = #PPCompositeParserTest
! !
!PPCompositeParserTest class methodsFor: #accessing!   
resources
	^ Array with: PPParserResource
!    !
!PPCompositeParserTest methodsFor: #utilities! 
assert: aCollection is: anObject
	| result |
	result := self parse: aCollection.
	self
		assert: result = anObject
		description: 'Got: ' , result printString , '; Expected: ' , anObject printString
		resumable: true
! !
!PPCompositeParserTest methodsFor: #utilities! 
parse: aString
	^ parser
		parse: aString
		onError: [ :err :pos | self error: err ]
! !
!PPCompositeParserTest methodsFor: #utilities! 
parse: aString production: aSymbol
	^ (parser productionAt: aSymbol)
		parse: aString
		onError: [ :err :pos | self error: err ].
!    !
!PPCompositeParserTest methodsFor: #accessing! 
parserClass
	self subclassResponsibility
! !
!PPCompositeParserTest methodsFor: #accessing! 
parserInstance
	^ PPParserResource current parserAt: self parserClass
!    !
!PPCompositeParserTest methodsFor: #running!   
setUp
	super setUp.
	parser := self parserInstance
!   !
