"evaluate"
PPCompositeParser subclass: #PPLambdaParser
instanceVariableNames: 
	' expression abstraction application variable '
classVariableNames: ''
poolDictionaries: ''
!
"evaluate"   
PPCompositeParser subclass: #PPArithmeticParser
instanceVariableNames: 
	' terms addition factors multiplication power primary parentheses number '
classVariableNames: ''
poolDictionaries: ''
!
!PPLambdaParser class methodsFor: #'curch-booleans'!  
and
	^ self parse: '\p.\q.((p q) p)'
! !
!PPLambdaParser class methodsFor: #'curch-booleans'!   
false
	^ self parse: '\x.\y.y'
!   !
!PPLambdaParser class methodsFor: #'curch-booleans'!   
ifthenelse
	^ self parse: '\p.p'
! !
!PPLambdaParser class methodsFor: #'curch-booleans'!   
not
	^ self parse: '\p.\a.\b.((p b) a)'
!  !
!PPLambdaParser class methodsFor: #'curch-booleans'!   
or
	^ self parse: '\p.\q.((p p) q)'
!  !
!PPLambdaParser class methodsFor: #'curch-booleans'!   
true
	^ self parse: '\x.\y.x'
!    !
!PPLambdaParser methodsFor: #productions!  
abstraction
	^ $\ asParser token trim , variable , $. asParser token trim , expression ==> [ :node | Array with: node second with: node fourth ]
! !
!PPLambdaParser methodsFor: #productions!  
application
	^ $( asParser token trim , expression , expression , $) asParser token trim ==> [ :node | Array with: node second with: node third ]
!    !
!PPLambdaParser methodsFor: #productions!  
expression
	^ variable / abstraction / application
!   !
!PPLambdaParser methodsFor: #productions!  
variable
	^ (#letter asParser , #word asParser star) token trim ==> [ :token | token value ]
! !
!PPLambdaParser methodsFor: #accessing!
start
	^ expression end
!  !
!PPArithmeticParser methodsFor: #grammar!  
addition
	^ (factors separatedBy: ($+ asParser / $- asParser) token trim) 
		foldLeft: [ :a :op :b | a perform: op value asSymbol with: b ]
!  !
!PPArithmeticParser methodsFor: #grammar!  
factors
	^ multiplication / power
!    !
!PPArithmeticParser methodsFor: #grammar!  
multiplication
	^ (power separatedBy: ($* asParser / $/ asParser) token trim)
		foldLeft: [ :a :op :b | a perform: op value asSymbol with: b ]
!   !
!PPArithmeticParser methodsFor: #grammar!  
number
	^ ($- asParser optional , #digit asParser plus , ($. asParser , #digit asParser plus) optional) token trim ==> [ :token | token value asNumber ]
! !
!PPArithmeticParser methodsFor: #grammar!  
parentheses
	^ $( asParser flatten trim , terms , $) asParser flatten trim ==> #second
!   !
!PPArithmeticParser methodsFor: #grammar!  
power
	^ (primary separatedBy: $^ asParser token trim) foldRight: [ :a :op :b | a raisedTo: b ]
!  !
!PPArithmeticParser methodsFor: #grammar!  
primary
	^ number / parentheses
!  !
!PPArithmeticParser methodsFor: #grammar!  
terms
	^ addition / factors
!  !
!PPArithmeticParser methodsFor: #accessing!
start
	^ terms end
!   !
